! Software By Ragazzi - Kevin B. Erskine KErskine@Software-By-Ragazzi.com

!------------------------------------------------------------------------------
!-              Put buttons on the windows caption area (titlebar)
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!- Change Log
!------------------------------------------------------------------------------
!- 11 Aug, 2006   Kevin Erskine, Software By Ragazzi
!-                KErskine@Software-By-Ragazzi.com
!-
!-              1 Converted Original code from 
!-                  http://www.catch22.net/tuts/titlebar.asp
!-              ---------------------------------------------------------------
!- 15 Aug, 2006   Kevin Erskine, Software By Ragazzi
!-
!-              1 Decided to only support ICON and BITMAPs in the resource
!-                No longer tries to find the image on disk if it fails
!-              
!-              2 Need to clean up code, might have a little memory problem
!-                - this is in review
!-              ---------------------------------------------------------------
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!- Known \ outstanding problems
!------------------------------------------------------------------------------
!
! 2) When multiple windows are open the title bar color does not change when
!    the window has focus
!
!------------------------------------------------------------------------------

      Member()
      
!==============================================================================
      INCLUDE('SVAPI.INC'), ONCE
      INCLUDE('KeyCodes.clw'),ONCE
      
      INCLUDE('SBRWCB.inc'),ONCE  

gEnumerate                              BYTE,STATIC,PRIVATE

SBRWCB_ButtonSize                       EQUATE(16)

HTCAPTION                               EQUATE( 2)
HTBORDER                                EQUATE(18)
RGN_XOR                                 EQUATE( 3)

_BOOL                                   EQUATE(BYTE )
_DWORD                                  EQUATE(ULONG)
_HANDLE                                 EQUATE(UNSIGNED)
_HDC                                    EQUATE(UNSIGNED)
_HGLOBAL                                EQUATE(UNSIGNED)
_HINSTANCE                              EQUATE(UNSIGNED)
_HMODULE                                EQUATE(UNSIGNED)
_HPALETTE                               EQUATE(UNSIGNED)
_HRSRC                                  EQUATE(UNSIGNED)
_HICON                                  EQUATE(UNSIGNED)
_HBITMAP                                EQUATE(UNSIGNED)
_UINT                                   EQUATE(UNSIGNED)
_LPSTR                                  EQUATE(SIGNED)
_LP                                     EQUATE(SIGNED)
_WORD                                   EQUATE(USHORT)

SBRWCB_Edge                             EQUATE( 2)
SBRWCB_PropertyName                     CSTRING('Ragazzi_WCB_Class')

_BITMAP                                 GROUP,TYPE
bmType                                     LONG
bmWidth                                    LONG
bmHeight                                   LONG
bmWidthBytes                               LONG
bmPlanes                                   _WORD
bmBitsPixel                                _WORD
bmBits                                     LONG
                                        END

_BITMAPFILEHEADER                       GROUP
bfType                                     STRING(2)             ! type must be BM
bfSize                                     ULONG                 ! size of file in bytes
bfReserved1                                USHORT
bfReserved2                                USHORT
bfOffbits                                  ULONG                 ! byte offset (from bitmapfileheader to actual bitmap data)
                                        END

_BITMAPINFOHEADER                       EQUATE(BITMAPINFOHEADER)
_BITMAPINFO                             EQUATE(BITMAPINFO      )

_IconInfo                               GROUP,TYPE               ! Windows _IconInfo struct
fIcon                                      _BOOL                  ! TRUE specifies an icon; FALSE specifies a cursor.
xHotSpot                                   LONG                  ! Cursors only. The x-coord of the hot spot.
yHotSpot                                   LONG                  ! Same as above, but for the y-coord.
hbmMask                                    LONG                  ! _HANDLE to the bitmap AND mask (2,4,8,16 and 24 bit bitmaps).
hbmColor                                   LONG                  ! The icon bitmap.
                                        END

_PaletteEntry                            GROUP,TYPE
peRed                                      BYTE
peGreen                                    BYTE
peBlue                                     BYTE
peFlags                                    BYTE
                                        END

_LogPalette                              GROUP,TYPE
palVersion                                 _WORD
palNumEntries                              _WORD
palPalEntry                                LIKE(_PaletteEntry),dim(1)
                                        END

!==============================================================================
   MAP
      INCLUDE('SVAPIFNC.INC'), ONCE

      MODULE('CW_API')
SBRWCB_API_SPrintF                      PROCEDURE(*CSTRING,*CSTRING,LONG),C,RAW,NAME('_SPrintF')
SBRWCB_API_memcpy                       PROCEDURE(long lpDest, long lpSource, long nCount),long,proc,name('_memcpy')
      END

      MODULE('Win32')
SBRWCB_API_CombineRgn                   PROCEDURE(HRGN     hrgnDest, HRGN hrgnSrc1, HRGN hrgnSrc2, SIGNED fnCombineMode),SIGNED,PASCAL,NAME('CombineRgn')
SBRWCB_API_CopyImage                    PROCEDURE(_HANDLE hImage, UNSIGNED uType, SIGNED cxDesired, SIGNED cyDesired, UNSIGNED fuFlags),_HANDLE,PASCAL,NAME('CopyImage')
SBRWCB_API_CreatePalette                PROCEDURE(*_LogPalette lplgpl),SIGNED,RAW,PASCAL,NAME('CreatePalette')
SBRWCB_API_CreateRectRgnIndirect        PROCEDURE(*_RECT_  lprc),HRGN ,PASCAL,RAW,NAME('CreateRectRgnIndirect')
SBRWCB_API_DestroyIcon                  PROCEDURE(_HICON hIcon),BYTE,RAW,PASCAL,NAME('DestroyIcon'),PROC
SBRWCB_API_DrawIconEx                   PROCEDURE(_HANDLE hDC,SIGNED xLeft,SIGNED yTop,_HICON hIcon,SIGNED cxWidth,SIGNED cyWidth,UNSIGNED iStepIfAniCur,UNSIGNED hbrFlickerFreeDraw,UNSIGNED diFlags),SIGNED,RAW,PASCAL,PROC,NAME('DrawIconEx')
SBRWCB_API_EnumResourceNames            PROCEDURE(_HINSTANCE hModule, LONG lpszType, SIGNED lpEnumPROC, LONG lParam),_BOOL,PASCAL,NAME('EnumResourceNamesA')
SBRWCB_API_EnumResourceTypes            PROCEDURE(_HINSTANCE hModule,                SIGNED lpEnumPROC, LONG lParam),_BOOL,PASCAL,PROC,NAME('EnumResourceTypesA')
SBRWCB_API_FindResource                 PROCEDURE(_HMODULE hModule, *CSTRING lpName, *CSTRING lpType),_HRSRC,RAW,PASCAL,NAME('FindResourceA')
SBRWCB_API_FreeResource                 PROCEDURE(_HGLOBAL hglbResource),_BOOL,PROC,NAME('FreeResourceA'),PASCAL
SBRWCB_API_GetIconInfo                  PROCEDURE(_HICON hIcon, *_IconInfo pIconInfo), LONG, RAW, PASCAL, NAME('GetIconInfo')
SBRWCB_API_GetProp                      PROCEDURE(_HANDLE hWnd, _LPSTR lpString),UNSIGNED,PASCAL,NAME('GetPropA')
SBRWCB_API_GetWindowDC                  PROCEDURE(_HANDLE hWnd), UNSIGNED,PASCAL, NAME('GetWindowDC')
SBRWCB_API_InflateRect                  PROCEDURE(*_RECT_  lprc , SIGNED dx, SIGNED dy),BYTE,RAW,PASCAL,NAME('InflateRect'),PROC
SBRWCB_API_LoadImage                    PROCEDURE(_HANDLE hinst, *CSTRING lpszName, UNSIGNED uType, SIGNED cxDesired, SIGNED cyDesired, UNSIGNED fuLoad), UNSIGNED, RAW, PASCAL, NAME('LoadImageA')
SBRWCB_API_LoadResource                 PROCEDURE(_HMODULE hModule, _HRSRC hResInfo),_HANDLE,PASCAL,NAME('LoadResource')
SBRWCB_API_LockResource                 PROCEDURE(_HANDLE  hRes),_HANDLE,PASCAL,NAME('LockResource')
SBRWCB_API_OffsetRect                   PROCEDURE(*_RECT_  lpRect, SIGNED x, SIGNED y),SIGNED,RAW,PASCAL,NAME('OffsetRect'),PROC
SBRWCB_API_OutputDebugString            PROCEDURE(*CSTRING),PASCAL,RAW,NAME('OutputDebugStringA')
SBRWCB_API_RealizePalette               PROCEDURE(_HDC hdc),UNSIGNED,NAME('RealizePalette'),PROC,PASCAL
SBRWCB_API_RemoveProp                   PROCEDURE(_HANDLE hWnd, _LPSTR lpString),UNSIGNED,PASCAL,NAME('RemovePropA')
SBRWCB_API_SelectPalette                PROCEDURE(_HDC hdc, SIGNED hpal, _BOOL bForceBackground),SIGNED,NAME('SelectPalette'),PROC,PASCAL
SBRWCB_API_SetLastError                 PROCEDURE(_HANDLE dwErrCode),PASCAL,NAME('SetLastError')
SBRWCB_API_SetProp                      PROCEDURE(_HANDLE hWnd, _LPSTR lpString, UNSIGNED hData),SIGNED,PASCAL, NAME('SetPropA')
SBRWCB_API_setrect                      PROCEDURE(*_RECT_  lprc  , SIGNED xLeft, SIGNED yTop, SIGNED xRight, SIGNED yBottom),SIGNED,RAW,PASCAL,NAME('SetRect')
SBRWCB_API_SizeOfResource               PROCEDURE(_HMODULE hModule, _HANDLE hResInfo),SIGNED,PASCAL,NAME('SizeOfResource')
SBRWCB_API_UnlockResource               PROCEDURE(_HGLOBAL hglbResource),PASCAL
SBRWCB_API_GetSystemPaletteEntries      PROCEDURE(_HDC hdc,_UINT iStartIndex, _UINT nEntries, _HANDLE lppe),UNSIGNED,PASCAL,NAME('GetSystemPaletteEntries')
SBRWCB_API_LoadIcon                     PROCEDURE(_HINSTANCE hInstance, *CSTRING lpIconName), _HANDLE, RAW, PASCAL, NAME('LoadIconA')
SBRWCB_API_CreateIconFromResource       PROCEDURE(_HANDLE presbits, _DWORD dwResSize, _BOOL fIcon, _DWORD dwVer),_HICON ,PASCAL,NAME('CreateIconFromResource')
      END

SBRWCB_EnumResNameProc                  PROCEDURE(_HINSTANCE hInst, long lpszType, long lpszName, long lParam),_BOOL,PASCAL
SBRWCB_EnumResTypeProc                  PROCEDURE(_HINSTANCE hInst, long lpszType, long lParam),_BOOL,PASCAL

SBRWCB_CalcRightEdge                    PROCEDURE(_HANDLE hwnd),SIGNED
SBRWCB_CalcTopEdge                      PROCEDURE(_HANDLE hwnd),SIGNED
SBRWCB_CenterBitmap                     PROCEDURE(_HDC hdc, *_RECT_ rc, t_SBRWCB_Btn pBtnInfo)
SBRWCB_DebugWrite                       PROCEDURE(STRING pS)
SBRWCB_GetButtonRect                    PROCEDURE(Ragazzi_WCB_CLASS SBRWCB, _HANDLE hwnd, SIGNED Cnt, *_RECT_ rect, BYTE fWindowRelative)
SBRWCB_GetRightEdgeOffset               PROCEDURE(Ragazzi_WCB_CLASS SBRWCB, _HANDLE hwnd),SIGNED
SBRWCB_GetWinCapBtn                     PROCEDURE(_HANDLE hwnd),*Ragazzi_WCB_CLASS
SBRWCB_HiWord                           PROCEDURE(LONG),SHORT
SBRWCB_InsertButton                     PROCEDURE(UNSIGNED hwnd, *t_SBRWCB_Btn pBtnInfo),BYTE
SBRWCB_LButtonUp                        PROCEDURE(Ragazzi_WCB_CLASS SBRWCB, _HANDLE hwnd, UNSIGNED wParam, SIGNED lParam),SIGNED
SBRWCB_LongToHex                        PROCEDURE(LONG pDecValue),STRING
SBRWCB_LoWord                           PROCEDURE(LONG),SHORT
SBRWCB_MakeIntResource                  PROCEDURE(SHORT wInteger),SIGNED
SBRWCB_MakeWord                         PROCEDURE(BYTE LowByte, BYTE HiByte),SHORT
SBRWCB_MouseMove                        PROCEDURE(Ragazzi_WCB_CLASS SBRWCB, _HANDLE hwnd, UNSIGNED wParam, SIGNED lParam),SIGNED
SBRWCB_NCActivate                       PROCEDURE(Ragazzi_WCB_CLASS SBRWCB, _HANDLE hwnd, UNSIGNED wParam, SIGNED lParam),SIGNED
SBRWCB_NCHitTest                        PROCEDURE(Ragazzi_WCB_CLASS SBRWCB, _HANDLE hwnd, UNSIGNED wParam, SIGNED lParam),SIGNED
SBRWCB_NCLButtonDown                    PROCEDURE(Ragazzi_WCB_CLASS SBRWCB, _HANDLE hwnd, UNSIGNED pmsg, UNSIGNED wParam, SIGNED lParam),SIGNED
SBRWCB_NCPaint                          PROCEDURE(Ragazzi_WCB_CLASS SBRWCB, _HANDLE hwnd, HRGN hrgn),SIGNED
SBRWCB_NewWndPROC                       PROCEDURE(_HANDLE hwnd, UNSIGNED pmsg, UNSIGNED wParam, SIGNED lParam),SIGNED,PASCAL
SBRWCB_RedrawNC                         PROCEDURE(_HANDLE hwnd)
SBRWCB_RemoveButton                     PROCEDURE(_HANDLE hwnd),BYTE,PROC
SBRWCB_ReplaceText                      PROCEDURE(*? pLineOfText, STRING pSearchFor, STRING pReplaceWith, BYTE pCaseSensitive=0, BYTE p1stOnly=0, BYTE pTrace=0),LONG,PROC ! Declare PROCedure
SBRWCB_SetText                          PROCEDURE(Ragazzi_WCB_CLASS SBRWCB, _HANDLE hwnd, UNSIGNED wParam, SIGNED lParam),SIGNED
SBRWCB_Wrapper                          PROCEDURE(Ragazzi_WCB_CLASS SBRWCB, _HANDLE hwnd, UNSIGNED pmsg, UNSIGNED wParam, SIGNED lParam),SIGNED
SBRWCB_CreateDIBPalette                 PROCEDURE(_BITMAPINFO pBitmapInfo , *SIGNED  lpiNumColors),SIGNED
   END
!=============================================================================================
Ragazzi_WCB_CLASS.Construct             PROCEDURE
   CODE

      RETURN
!==============================================================================
Ragazzi_WCB_CLASS.Destruct              PROCEDURE
   CODE

      SELF.Kill()

      RETURN
!=============================================================================================
Ragazzi_WCB_Class.Init                  PROCEDURE(WINDOW pWindow)
wReturnValue                            BYTE
   CODE
!      SBRWCB_DebugWrite('SBRWCB : Init  ' & 0{PROP:Text} & ' MDI=' & 0{PROP:MDI})

      IF     0{PROP:Type} = CREATE:application  ! OK on Frame
      ELSIF ~0{PROP:MDI }                       ! Not Ok on NON-MDI Windows
             MESSAGE('Window Caption Buttons can only be used on MDI windows!||' |
                   & 'Window Title:  ' & 0{PROP:Text}, |
                     'Notification...',ICON:Hand,BUTTON:Ok)
             RETURN False
      END
!     -----------------------------
      Self.Window      &= pWindow
      Self.hApp         = SYSTEM     {PROP:AppInstance}
      Self.hWnd         = Self.Window{PROP:Handle     }
      
      wReturnValue    = SBRWCB_API_SetProp(Self.hWnd                   , |
                                           ADDRESS(SBRWCB_PropertyName), |
                                           ADDRESS(SELF))
      IF ~wReturnValue
          SBRWCB_DebugWrite('SBRWCB : Init : SBRWCB_API_SetProp : * FAILED * :' |
                          & ' wReturnValue=' & wReturnValue)
         RETURN False
      END
!     -----------------------------
      SELF.InitDone   = True
!     -----------------------------
      REGISTER(EVENT:OpenWindow , ADDRESS(Self.Open     ), ADDRESS(Self))
      REGISTER(EVENT:CloseWindow, ADDRESS(Self.Kill     ), ADDRESS(Self))
      REGISTER(EVENT:Notify     , ADDRESS(Self.TakeEvent), ADDRESS(Self))
!     -----------------------------
      SELF.OldWndPROC = 0{PROP:WNDPROC}
      0{PROP:WNDPROC} = ADDRESS(SBRWCB_NewWndPROC)

      RETURN True
!==============================================================================
Ragazzi_WCB_Class.Kill                  PROCEDURE
wReturnValue                            SIGNED
wBtnNo                                  SIGNED
wBtnCnt                                 SIGNED
   CODE
      IF ~SELF.InitDone
          RETURN Level:Benign
      END
!     -----------------------------
      SBRWCB_DebugWrite('SBRWCB : Kill  ' & 0{PROP:Text})

      wReturnValue    = SBRWCB_API_RemoveProp(Self.hWnd, |
                                              ADDRESS(SBRWCB_PropertyName))
!      0{PROP:WNDPROC} = SELF.OldWndPROC
!     -----------------------------
      SELF.InitDone = False
      wBtnCnt       = SELF.ButtonCnt
!     -----------------------------
      UNREGISTER(EVENT:OpenWindow , ADDRESS(Self.AddButtons), ADDRESS(Self))
      UNREGISTER(EVENT:CloseWindow, ADDRESS(Self.Kill      ), ADDRESS(Self))
      UNREGISTER(EVENT:Notify     , ADDRESS(Self.TakeEvent ), ADDRESS(Self))
!     -----------------------------
      LOOP wBtnNo = wBtnCnt TO 1 BY -1
            IF Self.Buttons[wBtnNo].hImage 
               CASE Self.Buttons[wBtnNo].ImageType 
                 OF IMAGE_ICON
                             SBRWCB_API_DestroyIcon(Self.Buttons[wBtnNo].hImage )
                 OF IMAGE_BITMAP
                             DeleteObject(Self.Buttons[wBtnNo].hImage )
               END
            END
      END
!     -----------------------------
      0{PROP:WNDPROC} = SELF.OldWndPROC
!     -----------------------------
      SELF.ButtonCnt  = 0

      RETURN  Level:Benign
!==============================================================================
Ragazzi_WCB_Class.AddItem               PROCEDURE(WINDOW pWindow, WindowCaptionButtons WCB)
    CODE
!      SBRWCB_DebugWrite('SBRWCB : AddItem ' & 0{PROP:Text} & ' MDI=' & 0{PROP:MDI})

      IF Self.Init(pWindow)
         Self.Window &= pWindow
         Self.WCB    &= WCB
      END
      
      RETURN
!==============================================================================
Ragazzi_WCB_Class.Open            PROCEDURE()                 
    CODE
!      SBRWCB_DebugWrite('SBRWCB : Open ' & 0{PROP:Text})

      IF ~SELF.InitDone
          RETURN Level:Benign
      END

      IF Self.WCB &= NULL
         Self.AddButtons()
      ELSE   
         Self.WCB.AddButtons()
      END

!      SELF.OldWndPROC = 0{PROP:WNDPROC}
!      0{PROP:WNDPROC} = ADDRESS(SBRWCB_NewWndPROC)

!      SBRWCB_NCPaint(Self, Self.hWnd, 1)

      RETURN Level:Benign
!=============================================================================================
Ragazzi_WCB_Class.AddButtons            PROCEDURE()                 ! * VIRTUAL
    CODE
!      SBRWCB_DebugWrite('SBRWCB : AddButtons ' & 0{PROP:Text})

      RETURN
!=============================================================================================
Ragazzi_WCB_Class.AddButton             PROCEDURE(STRING pRscName, SIGNED pBorder=0) !,BYTE,PROC

wReturnValue                            BYTE

wBtnInfo                                LIKE(t_SBRWCB_Btn)
   CODE
!      SBRWCB_DebugWrite('SBRWCB : AddButton ' & 0{PROP:Text} & '=' & pRscName)

      IF ~SELF.InitDone
          RETURN False
      END

      IF    INSTRING('ICO',UPPER(pRscName),1,1)

            wBtnInfo.hImage = SELF.ImageFromICO(pRscName, wBtnInfo)

      ELSIF INSTRING('BMP',UPPER(pRscName),1,1)

            wBtnInfo.hImage = SELF.ImageFromBMP(pRscName, wBtnInfo)

      ELSE
            SBRWCB_DebugWrite('SBRWCB : AddButton : LoadImage : * FAILED * : ' |
                              & pRscName & ' Unknown Image type - check extention')
            RETURN False
      END
      !-------------------------------------
      IF ~wBtnInfo.hImage
          SBRWCB_DebugWrite('SBRWCB : AddButton : LoadImage : * FAILED * : ' |
                            & pRscName)
          RETURN False
      END
      !-------------------------------------
      wBtnInfo.RightBorder = pBorder             
      wBtnInfo.NotifyCode  = NOTIFY:WinCapBtn             

      wReturnValue = SBRWCB_InsertButton(Self.hWnd, wBtnInfo)
      IF wReturnValue
         SBRWCB_RedrawNC(Self.hWnd)
      END
      
      RETURN wReturnValue
!==============================================================================
Ragazzi_WCB_Class.AddButtonFEq          PROCEDURE(SIGNED pImageFEq, SIGNED pBorder=0) !,BYTE,PROC
   CODE

      IF ~SELF.InitDone
          RETURN False
      END

      CASE pImageFEq{PROP:Type}
        OF CREATE:Button      ; RETURN SELF.AddButton(pImageFEq{PROP:Icon}, pBorder)
        OF CREATE:Image       ; RETURN SELF.AddButton(pImageFEq{PROP:Text}, pBorder)
        OF CREATE:Item        ; RETURN SELF.AddButton(pImageFEq{PROP:Icon}, pBorder)
      END
      
      RETURN False
!==============================================================================
Ragazzi_WCB_Class.ButtonClickedOn       PROCEDURE(SIGNED pButtonNo) ! * VIRTUAL
   CODE

      ! Call the windows interface if there is one 
      ! for calling window to do something
      
      IF NOT Self.WCB &= NULL 
             Self.WCB.ButtonClickedOn(pButtonNo)
      END

      RETURN
!==============================================================================
Ragazzi_WCB_CLASS.ImageFromICO          PROCEDURE(STRING pRscName, *t_SBRWCB_Btn pBtnInfo) !, SIGNED

wRscName                                CSTRING(81)
wRscType                                CSTRING(11)
wLoadOptions                            SIGNED

wReturnValue                            BYTE
   CODE

    CLEAR(pBtnInfo)
    pBtnInfo.ImageType   = IMAGE_ICON 
    pBtnInfo.Width       = SBRWCB_ButtonSize
    pBtnInfo.Height      = SBRWCB_ButtonSize
    
    wLoadOptions         = LR_CreateDIBSection |
                         + LR_Shared 

    wRscName   = CLIP(pRscName)

    SBRWCB_ReplaceText(wRscName, '~', '' , True, True)
    SBRWCB_ReplaceText(wRscName, '.', '_', True, True)
!==============================================================================    
!-  Try to load image from Resource, LOADIMAGE 

    pBtnInfo.hImage  = SBRWCB_API_LoadImage(Self.hApp        , |
                                            wRscName         , |
                                            IMAGE_Icon       , |
                                            SBRWCB_ButtonSize, |
                                            SBRWCB_ButtonSize, |
                                            wLoadOptions)

    IF pBtnInfo.hImage 
?      SBRWCB_DebugWrite('SBRWCB : ImageFromICO : LoadImage         RES: ' & wRscName & ' hImage=' & SBRWCB_LongToHex(pBtnInfo.hImage ))
       RETURN pBtnInfo.hImage 
    END
!==============================================================================    
!-  Try to load image from Resource, LOADRESOUCEIMAGE 

    wRscType         = RT_Icon

    pBtnInfo.hImage  = Self.LoadResouceImage(IMAGE_ICON, wRscName, wRscType)

    IF pBtnInfo.hImage 
?      SBRWCB_DebugWrite('SBRWCB : ImageFromICO : LoadResouceImage  RES: ' & wRscName & ' hImage=' & SBRWCB_LongToHex(pBtnInfo.hImage ))
       RETURN pBtnInfo.hImage 
    END
!==============================================================================    
!-  Try to load image from Resource, LOADICON 

    pBtnInfo.hImage  = SBRWCB_API_LoadIcon(Self.hApp, |
                                           wRscName)

    IF pBtnInfo.hImage 
?      SBRWCB_DebugWrite('SBRWCB : ImageFromICO : LoadIcon          RES: ' & wRscName & ' hImage=' & SBRWCB_LongToHex(pBtnInfo.hImage ))
       RETURN pBtnInfo.hImage 
    END

       SBRWCB_DebugWrite('SBRWCB : ImageFromICO : * FAILED TO LOAD  RES: ' & wRscName & ' hImage=' & SBRWCB_LongToHex(pBtnInfo.hImage ))
    RETURN pBtnInfo.hImage 
!==============================================================================
Ragazzi_WCB_CLASS.ImageFromBMP          PROCEDURE(STRING pRscName, *t_SBRWCB_Btn pBtnInfo) !, SIGNED

wRscName                                CSTRING(81)
wRscType                                CSTRING(11) 
wLoadOptions                            SIGNED

wReturnValue                            SIGNED
   CODE

    CLEAR(pBtnInfo)
    pBtnInfo.ImageType   = IMAGE_BITMAP
    
    wLoadOptions         = LR_CreateDIBSection
    wRscName             = CLIP(pRscName)

    SBRWCB_ReplaceText(wRscName, '~', '' , True, True)
    SBRWCB_ReplaceText(wRscName, '.', '_', True, True)
!==============================================================================    
!-  Try to load image from Resource, LOADIMAGE 

    pBtnInfo.hImage  = SBRWCB_API_LoadImage(Self.hApp        , |
                                            wRscName         , |
                                            IMAGE_BitMap     , |
                                            SBRWCB_ButtonSize, |
                                            SBRWCB_ButtonSize, |
                                            wLoadOptions)

    IF pBtnInfo.hImage 
?      SBRWCB_DebugWrite('SBRWCB : ImageFromBMP : LoadImage         RES: ' & wRscName & ' hImage=' & SBRWCB_LongToHex(pBtnInfo.hImage ))

       DO HANDLE:SetAttributes
       RETURN pBtnInfo.hImage 
    END
!==============================================================================    
!-  Try to load image from Resource, LOADRESOUCEIMAGE 

    wRscType         = 'IMAGE'

    pBtnInfo.hImage  = Self.LoadResouceImage(IMAGE_BITMAP, wRscName, wRscType)

    IF pBtnInfo.hImage  
?      SBRWCB_DebugWrite('SBRWCB : ImageFromBMP : LoadResouceImage1 RES: ' & wRscName & ' hImage=' & SBRWCB_LongToHex(pBtnInfo.hImage ))

       DO HANDLE:SetAttributes
       RETURN pBtnInfo.hImage 
    END
!==============================================================================    
!-  Try to load image from Resource, LOADRESOUCEIMAGE 

    wRscType         = RT_BITMAP

    pBtnInfo.hImage  = Self.LoadResouceImage(IMAGE_BITMAP, wRscName, wRscType)

    IF pBtnInfo.hImage  
?      SBRWCB_DebugWrite('SBRWCB : ImageFromBMP : LoadResouceImage2 RES: ' & wRscName & ' hImage=' & SBRWCB_LongToHex(pBtnInfo.hImage ))

       DO HANDLE:SetAttributes
       RETURN pBtnInfo.hImage 
    END
    
       SBRWCB_DebugWrite('SBRWCB : ImageFromBMP : * FAILED TO LOAD  RES: ' & wRscName & ' hImage=' & SBRWCB_LongToHex(pBtnInfo.hImage ))
    RETURN pBtnInfo.hImage 
!==============================================================================    
HANDLE:SetAttributes                  ROUTINE
   DATA
bm                                      LIKE(BitMap)
   CODE

      wReturnValue    = GetObject(pBtnInfo.hImage , SIZE(bm), ADDRESS(bm))
      pBtnInfo.Width  = bm.bmWidth
      pBtnInfo.Height = bm.bmHeight

 EXIT
?     SBRWCB_DebugWrite('SBRWCB : ImageFromBMP : bmType      =' & bm.bmType      )
?     SBRWCB_DebugWrite('SBRWCB : ImageFromBMP : bmWidth     =' & bm.bmWidth     )
?     SBRWCB_DebugWrite('SBRWCB : ImageFromBMP : bmHeight    =' & bm.bmHeight    )
?     SBRWCB_DebugWrite('SBRWCB : ImageFromBMP : bmWidthBytes=' & bm.bmWidthBytes)
?     SBRWCB_DebugWrite('SBRWCB : ImageFromBMP : bmPlanes    =' & bm.bmPlanes    )
?     SBRWCB_DebugWrite('SBRWCB : ImageFromBMP : bmBitsPixel =' & bm.bmBitsPixel )
?     SBRWCB_DebugWrite('SBRWCB : ImageFromBMP : bmBits      =' & bm.bmBits      )
      EXIT
!==============================================================================
Ragazzi_WCB_Class.TakeEvent             PROCEDURE()
NotifyCode                              SIGNED
ThreadNo                                SIGNED
Parameter                               SIGNED
   CODE

      IF EVENT() NOT = EVENT:Notify
         RETURN  Level:Benign
      END

      IF NOT NOTIFICATION(NotifyCode, ThreadNo, Parameter)
         RETURN  Level:Benign
      END

      CASE NotifyCode
        OF NOTIFY:WinCapBtn    ; SELF.ButtonClickedOn(Parameter) ! Pass Button No
      END

      RETURN  Level:Benign
!==============================================================================
Ragazzi_WCB_Class.EnumResourceTypes       PROCEDURE
    CODE
    
    SBRWCB_API_EnumResourceTypes(Self.hApp, ADDRESS(SBRWCB_EnumResTypeProc), 1)

    RETURN
!==============================================================================
Ragazzi_WCB_Class.LoadResouceImage       PROCEDURE(BYTE pImageType, *CSTRING pRscName, *CSTRING pRscType) !,_HANDLE,PRIVATE

hImage                                  _HANDLE

hRscInfoBlock                           _HRSRC    
hRscAssocData                           _HGLOBAL  
hRscLockedData                          _LP
wRscSize                                SIGNED

wPalette                                LIKE(_PaletteEntry)
hPalette                                &_PaletteEntry

wBitMapFileHeader                       LIKE(_BITMAPFILEHEADER)

wBitmapInfo                             LIKE(_BITMAPINFO      )
wBitmapInfoHeader                       LIKE(_BitmapInfoHeader),OVER(wBitmapInfo)

hImageData                              _HANDLE
hImageTemp                              _HANDLE

hdc                                     _HDC
wCnt                                    SIGNED
iNumColors                              SIGNED

   CODE
      hRscInfoBlock  = SBRWCB_API_FindResource(Self.hApp, pRscName, pRscType)

      IF ~hRscInfoBlock
          SBRWCB_DebugWrite('SBRWCB : LoadRscImage : FindResource RES: ' & pRscName & ' pRscType=' & pRscType & ' hRscInfoBlock=' & SBRWCB_LongToHex(hRscInfoBlock))
          RETURN hImage    
      END
      !----------------
      wRscSize       = SBRWCB_API_SizeofResource(Self.hApp, hRscInfoBlock)

      IF ~hRscInfoBlock
          SBRWCB_DebugWrite('SBRWCB : LoadRscImage : SizeofResource     wRscSize   =' & wRscSize)
          RETURN hImage    
      END
      !----------------
      hRscAssocData  = SBRWCB_API_LoadResource(Self.hApp, hRscInfoBlock)

      IF ~hRscAssocData
          SBRWCB_DebugWrite('SBRWCB : LoadRscImage : LoadResource     hRscAssocData   =' & SBRWCB_LongToHex(hRscAssocData))
          RETURN hImage    
      END
      !----------------
      hRscLockedData = SBRWCB_API_LockResource(hRscAssocData)

      IF ~hRscLockedData
          SBRWCB_DebugWrite('SBRWCB : LoadRscImage : LockResource   hRscLockedData=' & SBRWCB_LongToHex(hRscLockedData))
          RETURN hImage    
      END
!==============================================================================
    CASE pImageType
      OF IMAGE_BITMAP    ;  DO Handle:Load:BMP   
      OF IMAGE_ICON      ;  DO Handle:Load:ICO   
    END
!==============================================================================
    RETURN hImage    
!==============================================================================
Handle:Load:ICO                ROUTINE
 !-
  hImage     = SBRWCB_API_CreateIconFromResource(hRscLockedData, |
                                                 wRscSize      , |
                                                 True          , |
                                                 00030000h)
  IF GetLastError()
     SBRWCB_DebugWrite('SBRWCB : LoadRscImage : CreateIconFromResource')
  END
 !-
  EXIT
!==============================================================================
Handle:Load:BMP                ROUTINE
 !-
  MoveMemory(ADDRESS(wBitMapFileHeader), hRscLockedData, SIZE(wBitMapFileHeader))

  MoveMemory(ADDRESS(wBitmapInfo      ), hRscLockedData |
                                       + SIZE(wBitMapFileHeader), SIZE(wBitmapInfo))
!----------------------------------
  hdc  = SBRWCB_API_GetWindowDC(0{PROP:Handle})
  IF GetLastError()
     SBRWCB_DebugWrite('SBRWCB : LoadRscImage : GetWindowDC')
  END
!----------------------------------
  hPalette  = SBRWCB_CreateDIBPalette (wBitmapInfo, iNumColors)

  IF ~hPalette
      wCnt = SBRWCB_API_GetSystemPaletteEntries(hdc, 1, 1, 0)
      IF GetLastError()
         SBRWCB_DebugWrite('SBRWCB : LoadRscImage : GetSystemPaletteEntries')
      END

      IF wCnt
         hPalette = ADDRESS(wPalette)
         wCnt = SBRWCB_API_GetSystemPaletteEntries(hdc, 1, 1, hPalette)
         IF GetLastError()
            SBRWCB_DebugWrite('SBRWCB : LoadRscImage : GetSystemPaletteEntries')
         END
      END
  END
  IF hPalette
     SBRWCB_API_SelectPalette (hdc,hPalette,False)
     IF GetLastError()
        SBRWCB_DebugWrite('SBRWCB : LoadRscImage : SelectPalette')
     END

     SBRWCB_API_RealizePalette(hdc)
     IF GetLastError()
        SBRWCB_DebugWrite('SBRWCB : LoadRscImage : RealizePalette')
     END
  END
!----------------------------------
  hImageData = hRscLockedData          |
             + SIZE(wBitMapFileHeader) |
             + wBitmapInfo.biSize      |
             + (iNumColors * SIZE(RGBQUAD))

  hImageTemp = CreateDIBitmap(hdc              , |
                              wBitmapInfoHeader, |
                              CBM_INIT         , |
                              hImageData       , |
                              wBitmapInfo      , |
                              DIB_RGB_COLORS)
  IF ~hImageTemp |
  OR  GetLastError()
      SBRWCB_DebugWrite('SBRWCB : LoadRscImage : CreateDIBitmap')
  END
!----------------------------------
  hImage     = SBRWCB_API_CopyImage (hImageTemp       ,|
                                     IMAGE_BitMap     ,|
                                     SBRWCB_ButtonSize,|
                                     SBRWCB_ButtonSize,|
                                     LR_COPYDELETEORG)
  IF ~hImage |
  OR  GetLastError()
      SBRWCB_DebugWrite('SBRWCB : LoadRscImage : CopyImage')
  END

  IF hPalette
     DeleteObject(hPalette)
     IF GetLastError()
        SBRWCB_DebugWrite('SBRWCB : LoadRscImage : DeleteObject')
     END
  END

  ReleaseDC(0,hdc)
  IF GetLastError()
     SBRWCB_DebugWrite('SBRWCB : LoadRscImage : ReleaseDC')
  END
 !-
  EXIT
!==============================================================================
SBRWCB_GetWinCapBtn                     PROCEDURE(_HANDLE hwnd) !,*Ragazzi_WCB_Class
SBRWCB                                  &Ragazzi_WCB_Class
   CODE

      SBRWCB &= (SBRWCB_API_GetProp(hwnd, ADDRESS(SBRWCB_PropertyName)))

      RETURN SBRWCB
!==============================================================================
!=== Internal Support PROCedures for the buttons
!==============================================================================
SBRWCB_RedrawNC                         PROCEDURE(_HANDLE hwnd)
   CODE

      SetWindowPos(hwnd, 0, 0, 0, 0, 0, SWP_NOMOVE     |
                                      + SWP_NOSIZE     |
                                      + SWP_NOZORDER   |
                                      + SWP_NOACTIVATE |
                                      + SWP_DRAWFRAME)

      RETURN
!==============================================================================
SBRWCB_CalcTopEdge                      PROCEDURE(_HANDLE hwnd) !,SIGNED
dwStyle                                 SIGNED
   CODE

      dwStyle = GetWindowLong(hwnd, GWL_STYLE)

      IF(BAND(dwStyle,WS_THICKFRAME))
         RETURN GetSystemMetrics(SM_CYSIZEFRAME)
      ELSE
         RETURN GetSystemMetrics(SM_CYFIXEDFRAME)
      END
!==============================================================================
SBRWCB_CalcRightEdge                    PROCEDURE(_HANDLE hwnd) !,SIGNED
dwStyle                                 SIGNED
   CODE

      dwStyle = GetWindowLong(hwnd, GWL_STYLE)

      IF(BAND(dwStyle,WS_THICKFRAME))
         RETURN GetSystemMetrics(SM_CXSIZEFRAME)
      ELSE
         RETURN GetSystemMetrics(SM_CXFIXEDFRAME)
      END
!==============================================================================
!
!   Return the starting position of the first inserted button.
!   We need to take into account the size of the close button,
!   The minimize, maximize buttons etc
!
!   -------------------------------------------------\
!                                         [-][+] [X] |
!                                        ^
!                                        |           |
!                    Return is pos       |--- Ret  --|
!
!
SBRWCB_GetRightEdgeOffset               PROCEDURE(Ragazzi_WCB_Class SBRWCB, _HANDLE hwnd) !,SIGNED
dwStyle                                 SIGNED
dwExStyle                               SIGNED
nButSize                                SIGNED
nSysButSize                             SIGNED
   CODE

      dwStyle   = GetWindowLong(hwnd, GWL_STYLE)
      dwExStyle = GetWindowLong(hwnd, GWL_EXSTYLE)

      IF(BAND(dwExStyle,WS_EX_TOOLWINDOW))

         nSysButSize = GetSystemMetrics(SM_CXSMSIZE) - SBRWCB_Edge

         IF(BAND(dwStyle,WS_SYSMENU))
            nButSize += nSysButSize + SBRWCB_Edge
         END

         RETURN nButSize + SBRWCB_CalcRightEdge(hwnd)
      ELSE
         nSysButSize = GetSystemMetrics(SM_CXSIZE) - SBRWCB_Edge

        !  Window has Close [X] button. This button has a 2-pixel
        !  border on either size

         IF(BAND(dwStyle,WS_SYSMENU))
            nButSize += nSysButSize + SBRWCB_Edge
         END

        !  If either of the minimize or maximize buttons are shown,
        !  Then both will appear (but may be disabled)
        !  This button pair has a 2 pixel border on the left

         IF(BAND(dwStyle,(WS_MINIMIZEBOX + WS_MAXIMIZEBOX)))

            nButSize += SBRWCB_Edge + nSysButSize * 2

        !  A window can have a question-mark button, but only
        !  if it doesn't have any min/max buttons

         ELSIF(BAND(dwExStyle,WS_EX_CONTEXTHELP))

            nButSize += SBRWCB_Edge + nSysButSize

         END

        !  Now calculate the size of the border...aggghh!

         RETURN nButSize + SBRWCB_CalcRightEdge(hwnd)
      END
!==============================================================================
!
!   Input  - rect is coords of window rectangle
!            (in screen or relative coords)
!
!   Output - rect is adjusted to describe button rectangle
!
SBRWCB_GetButtonRect                    PROCEDURE(Ragazzi_WCB_Class SBRWCB, _HANDLE hwnd, SIGNED BtnNo, *_RECT_ rect, BYTE fWindowRelative)
wBtnNo                                  SIGNED
re_START                                SIGNED
cxBut                                   SIGNED
cyBut                                   SIGNED

wReturnValue                            SIGNED
   CODE
!?     SBRWCB_DebugWrite('SBRWCB : GetButtonRect : BtnNo=' & BtnNo & ' fWindowRelative=' & fWindowRelative)

      IF(BAND(GetWindowLong(hwnd, GWL_EXSTYLE),WS_EX_TOOLWINDOW))
         cxBut = GetSystemMetrics(SM_CXSMSIZE)
         cyBut = GetSystemMetrics(SM_CYSMSIZE)
      ELSE
         cxBut = GetSystemMetrics(SM_CXSIZE)
         cyBut = GetSystemMetrics(SM_CYSIZE)
      END

    !  right-edge starting point of inserted buttons

      re_START = SBRWCB_GetRightEdgeOffset(SBRWCB, hwnd)

      wReturnValue = GetWindowRect(hwnd, rect)

      IF(fWindowRelative)

         wReturnValue = SBRWCB_API_OffsetRect(rect, -rect.Left, -rect.top)
         
      END

    ! Find the correct button - but take into
    ! account all other buttons.

      LOOP wBtnNo = 1 TO BtnNo

           re_START += SBRWCB.Buttons[wBtnNo].RightBorder + cxBut - SBRWCB_Edge

      END

      rect.Left   = rect.Right - re_START
      rect.top    = rect.top   + SBRWCB_CalcTopEdge(hwnd) +  SBRWCB_Edge
      rect.Right  = rect.Left  + cxBut - SBRWCB_Edge
      rect.bottom = rect.top   + cyBut - SBRWCB_Edge * 2

      RETURN
!==============================================================================
SBRWCB_NCHitTest                     PROCEDURE(Ragazzi_WCB_Class SBRWCB, _HANDLE hwnd, UNSIGNED wParam, SIGNED lParam) !,SIGNED
rect                                    LIKE(_RECT_)
pt                                      LIKE(POINT)
wBtnNo                                  SIGNED
ret                                     SIGNED 
wReturnValue                            SIGNED
   CODE
!      SBRWCB_DebugWrite('SBRWCB : NCHitTest : ')

      pt.x = SBRWCB_LoWord(lParam)
      pt.y = SBRWCB_HiWord(lParam)

      ret = CallWindowPROC(SBRWCB.OldWndPROC, hwnd, WM_NCHITTEST, wParam, lParam)

    ! If the mouse is in the caption, then check to
    ! see if it is over one of our buttons

      IF(ret = HTCAPTION)
         LOOP wBtnNo = 1 TO SBRWCB.ButtonCnt

            SBRWCB_GetButtonRect(SBRWCB, hwnd, wBtnNo, rect, False)

            wReturnValue = SBRWCB_API_InflateRect(rect, 0, SBRWCB_Edge)

            ! If the mouse is in any custom button, then
            ! We need to override the default behaviour.

            IF(PtInRect(rect, pt))
               RETURN HTBORDER
            END
         END
      END

      RETURN ret
!==============================================================================
!   If hBitmap is MONOCHROME then
!   whites will be drawn transparently,
!   blacks will be drawn normally
!   So, it will look just like a caption button
!
!   If hBitmap is > 2 colours, then no transparent
!   drawing will take place....Ndx.e. DIY!
!
! http://msdn.microsoft.com/library/default.asp?url=/library/en-us/winui/winui/windowsuserinterface/resources/menus/usingmenus.asp
!
SBRWCB_CenterBitmap                     PROCEDURE(_HDC hdc, *_RECT_ rc, t_SBRWCB_Btn pBtnInfo)
bm                                      LIKE(BITMAP)

wIconInfo                               LIKE(_IconInfo)

cx                                      SIGNED
cy                                      SIGNED
memdc                                   _HDC
hOldBM                                  SIGNED
rcDest                                  LIKE(_RECT_)
p                                       LIKE(POINT)
delta                                   LIKE(SIZE)
colorOld                                COLORREF


wReturnValue                            SIGNED
   CODE
      IF(pBtnInfo.hImage  = 0)
         RETURN
      END

      rcDest = rc

    !  center bitmap in caller's rectangle
 
!OLD!     CASE pBtnInfo.ImageType
!OLD!       OF IMAGE_ICON
!OLD!               wReturnValue = SBRWCB_API_GetIconInfo(pBtnInfo.hImage , wIconInfo)

!OLD!               cx = SBRWCB_ButtonSize
!OLD!               cy = SBRWCB_ButtonSize

!OLD!               DeleteObject(wIconInfo.hbmColor)
!OLD!               DeleteObject(wIconInfo.hbmMask )
!OLD!          !------------------------------------------------------------
!OLD!       OF IMAGE_BITMAP 
!OLD!               wReturnValue = GetObject(pBtnInfo.hImage , size(bm), ADDRESS(bm))

!OLD!               cx = wBitMap.bmWidth
!OLD!               cy = wBitMap.bmHeight
!OLD!     END
!OLD!     
!OLD!     
!OLD!     IF ~wReturnValue
!OLD!         SBRWCB_DebugWrite('SBRWCB : CenterBitmap : GetObject wReturnValue=' & wReturnValue)
!OLD!         RETURN
!OLD!     END
      
      cx = pBtnInfo.Width
      cy = pBtnInfo.Height
      
      delta.cx = (rc.Right  - rc.Left - cx) / 2
      delta.cy = (rc.bottom - rc.top  - cy) / 2

!?     SBRWCB_DebugWrite('SBRWCB : CenterBitmap : hdc='      & SBRWCB_LongToHex(hdc) |
!?                                           & ': pBtnInfo.hImage ='  & SBRWCB_LongToHex(pBtnInfo.hImage ) |
!?                                           & ' rc.top='    & rc.top    |
!?                                           & ' rc.Left='   & rc.Left   |
!?                                           & ' rc.bottom=' & rc.bottom |
!?                                           & ' rc.Right='  & rc.Right  |
!?                                           & ' cx='        & cx        |
!?                                           & ' cy='        & cy)

      IF(rc.Right-rc.Left > cx)
         wReturnValue  = SBRWCB_API_SetRect(rcDest, rc.Left+delta.cx, rc.top + delta.cy, 0, 0)
         IF ~wReturnValue
             SBRWCB_DebugWrite('SBRWCB : CenterBitmap : SetRect wReturnValue=' & wReturnValue)
             RETURN
         END

         rcDest.Right  = rcDest.Left + cx
         rcDest.bottom = rcDest.top + cy
         p.x           = 0
         p.y           = 0
      ELSE
         p.x = -delta.cx
         p.y = -delta.cy
      END

     CASE pBtnInfo.ImageType
       OF IMAGE_ICON
               colorOld = SetBkColor(hdc, GetSysColor(COLOR_3DFACE))
               
               wReturnValue = SBRWCB_API_DrawIconEx(hDC             , |
                                                    rcDest.left     , |
                                                    rcDest.top      , |
                                                    pBtnInfo.hImage , |
                                                    0,0,0,0,3)! Draw selected icon 
                 IF ~wReturnValue
                     SBRWCB_DebugWrite('SBRWCB : CenterBitmap : DrawIconEx wReturnValue=' & wReturnValue)
                 END

                SetBkColor  (hdc  , colorOld)
          !------------------------------------------------------------
       OF IMAGE_BITMAP 
                !  select checkmark into memory DC

                  memdc  = CreateCompatibleDC(hdc)
                  IF ~memdc
                      SBRWCB_DebugWrite('SBRWCB : CenterBitmap : CreateCompatibleDC memdc=' & memdc)
                      RETURN
                  END

                  hOldBM = SelectObject(memdc, pBtnInfo.hImage )
                  IF ~hOldBM
                      SBRWCB_DebugWrite('SBRWCB : CenterBitmap : SelectObject hOldBM=' & hOldBM)
                      RETURN
                  END

                !  set BG color based on selected state

                 colorOld = SetBkColor(hdc, GetSysColor(COLOR_3DFACE))

               wReturnValue = BitBlt(hdc, rcDest.Left               , |
                                          rcDest.top                , |
                                          rcDest.Right-rcDest.Left  , |
                                          rcDest.bottom-rcDest.top  , |
                                          memdc                     , |
                                          p.x                       , |
                                          p.y                       , |
                                          SRCCOPY)
                 IF ~wReturnValue
                     SBRWCB_DebugWrite('SBRWCB : CenterBitmap : BitBlt wReturnValue=' & wReturnValue)
                 END

                 !  restore

                  SetBkColor  (hdc  , colorOld)
                  SelectObject(memdc, hOldBM  )
                  DeleteDC    (memdc)
     END

      RETURN
!==============================================================================
SBRWCB_NCPaint                       PROCEDURE(Ragazzi_WCB_Class SBRWCB, _HANDLE hwnd, HRGN hrgn) !,SIGNED
rect                                    LIKE(_RECT_)
rect1                                   LIKE(_RECT_)
fRegionOwner                            BYTE
wBtnNo                                  SIGNED
hdc                                     _HDC
uButType                                UNSIGNED
x                                       SIGNED
y                                       SIGNED
hrgn1                                   HRGN

wBtnInfo                                LIKE(t_SBRWCB_Btn)

wReturnValue                            SIGNED
   CODE
!?     SBRWCB_DebugWrite('SBRWCB : NCPaint : hrgn=' & hrgn)
 
      fRegionOwner = False

      GetWindowRect(hwnd, rect)

      x = rect.Left
      y = rect.top

    ! Create a region which covers the whole window. This
    ! must be in screen coordinates
      IF(hrgn = 1  OR  hrgn = 0)
         hrgn         = SBRWCB_API_CreateRectRgnIndirect(rect)
         fRegionOwner = True
      END

    !  Clip our custom buttons out of the way...
      LOOP wBtnNo = 1 TO SBRWCB.ButtonCnt
        ! Get button rectangle in screen coords
         SBRWCB_GetButtonRect(SBRWCB, hwnd, wBtnNo, rect1, False)

         hrgn1 = SBRWCB_API_CreateRectRgnIndirect(rect1)

        ! Cut out a button-shaped hole
         wReturnValue = SBRWCB_API_CombineRgn(hrgn, hrgn, hrgn1, RGN_XOR)

         DeleteObject(hrgn1)
      END

    !
    !   Call the default window PROCedure with our modified window region!
    !   (REGION MUST BE IN SCREEN COORDINATES)
    !
      wReturnValue = CallWindowPROC(SBRWCB.OldWndPROC, hwnd, WM_NCPAINT, hrgn, 0)

    !
    !   Now paint our custom buttons in the holes that are
    !   left by our clipping. All drawing in the Non-client area
    !   is window-relative (Not in screen coords)
    !

      hdc = SBRWCB_API_GetWindowDC(hwnd)
!?     SBRWCB_DebugWrite('SBRWCB : NCPaint : GetWindowDC : hwnd=' & SBRWCB_LongToHex(hwnd) & ' hdc=' & SBRWCB_LongToHex(hdc))

    !  Draw buttons in a loop
      LOOP wBtnNo = 1 TO SBRWCB.ButtonCnt
        ! Get Button rect in window coords
         SBRWCB_GetButtonRect(SBRWCB, hwnd, wBtnNo, rect1, True)

         IF(SBRWCB.Buttons[wBtnNo].hImage )
            uButType = DFCS_BUTTONPUSH
         ELSE
            uButType = DFCS_BUTTONPUSH
         END

         IF(SBRWCB.Buttons[wBtnNo].Pressed)
            wReturnValue = DrawFrameControl(hdc, rect1, DFC_BUTTON, uButType + DFCS_PUSHED)
         ELSE
            wReturnValue = DrawFrameControl(hdc, rect1, DFC_BUTTON, uButType)
         END

        ! Now draw the bitmap!
         SBRWCB_API_InflateRect(rect1, -2, -2)
         rect1.Right  -= 1
         rect1.bottom -= 1

         IF(SBRWCB.Buttons[wBtnNo].Pressed)
            SBRWCB_API_OffsetRect(rect1, 1, 1)
         END

         wBtnInfo = SBRWCB.Buttons[wBtnNo]  
         
         SBRWCB_CenterBitmap(hdc, rect1, wBtnInfo)
      END

      ReleaseDC(hwnd, hdc)

      IF(fRegionOwner)
         DeleteObject(hrgn)
      END

      RETURN 0
!==============================================================================
!   This is a generic message _HANDLEr used by WM_SETTEXT and WM_NCACTIVATE.
!   It works by turning off the WS_VISIBLE style, calling
!   the original window PROCedure, then turning WS_VISIBLE back on.
!
!   This prevents the original wndPROC from redrawing the caption.
!   Last of all, we paint the caption ourselves with the inserted buttons
!
SBRWCB_Wrapper                         PROCEDURE(Ragazzi_WCB_Class SBRWCB, _HANDLE hwnd, UNSIGNED pmsg, UNSIGNED wParam, SIGNED lParam) !,SIGNED
ret                                     UNSIGNED
dwStyle                                 SIGNED
   CODE
      dwStyle = GetWindowLong(hwnd, GWL_STYLE)

    ! Turn OFF WS_VISIBLE, so that WM_NCACTIVATE does not
    ! paint our window caption...

!******
!******
    ! I think this line of code is wrong, original line was 
    
    ! SetWindowLong(hwnd, GWL_STYLE, dwStyle & ~WS_VISIBLE);

      SetWindowLong(hwnd, GWL_STYLE, BXOR(dwStyle,WS_VISIBLE))
!******
!******
    ! Do the default thing..
      ret = CallWindowPROC(SBRWCB.OldWndPROC, hwnd, pmsg, wParam, lParam)
!?     SBRWCB_DebugWrite('SBRWCB : Wrapper : CallWindowPROC : ret=' & ret)

    ! Restore the original style
      SetWindowLong(hwnd, GWL_STYLE, dwStyle)

    ! Paint the whole window frame + caption
      ret = SBRWCB_NCPaint(SBRWCB, hwnd, 1)
!?     SBRWCB_DebugWrite('SBRWCB : Wrapper : SBRWCB_NCPaint : ret=' & ret)

      RETURN ret
!==============================================================================
SBRWCB_NCActivate                      PROCEDURE(Ragazzi_WCB_Class SBRWCB, _HANDLE hwnd, UNSIGNED wParam, SIGNED lParam) !,SIGNED
   CODE
!      SBRWCB_DebugWrite('SBRWCB : NCActivate : ')

      RETURN SBRWCB_Wrapper(SBRWCB, hwnd, WM_NCACTIVATE, wParam, lParam);
!==============================================================================
SBRWCB_SetText                         PROCEDURE(Ragazzi_WCB_Class SBRWCB, _HANDLE hwnd, UNSIGNED wParam, SIGNED lParam) !,SIGNED
   CODE
!      SBRWCB_DebugWrite('SBRWCB : SetText : ')

      RETURN SBRWCB_Wrapper(SBRWCB, hwnd, WM_SETTEXT, wParam, lParam);
!==============================================================================
!
!   NonClient Left Button Down.
!   Mouse is in screen coordinates
!
SBRWCB_NCLButtonDown                   PROCEDURE(Ragazzi_WCB_Class SBRWCB, _HANDLE hwnd, UNSIGNED pmsg, UNSIGNED wParam, SIGNED lParam) !,SIGNED
wBtnNo                                  SIGNED
rect                                    LIKE(_RECT_)
pt                                      LIKE(POINT)
wReturnValue                            SIGNED
   CODE
!      SBRWCB_DebugWrite('SBRWCB : NCLButtonDown : ' & SBRWCB.ActiveButton)

      pt.x = SBRWCB_LoWord(lParam)
      pt.y = SBRWCB_HiWord(lParam)

    ! If mouse has been clicked in caption
    ! (Note: the NCHITTEST _HANDLEr changes HTCAPTION to HTBORDER
    !        if we are over an inserted button)

      IF(wParam = HTBORDER)

         LOOP wBtnNo = 1 TO SBRWCB.ButtonCnt
            SBRWCB_GetButtonRect(SBRWCB, hwnd, wBtnNo, rect, False)
            SBRWCB_API_InflateRect(rect, 0, 2)

            ! if clicked in a custom button
            IF(PtInRect(rect, pt))
               SBRWCB.ActiveButton            = wBtnNo
               SBRWCB.Buttons[wBtnNo].Pressed = True
               SBRWCB.MouseDown               = True

               wReturnValue = SetCapture(hwnd)

               SBRWCB_RedrawNC(hwnd)

               RETURN 0
            END
         END
      END

      RETURN CallWindowPROC(SBRWCB.OldWndPROC, hwnd, pmsg, wParam, lParam)
!==============================================================================
!
!   Left-button UP. Coords are CLIENT relative
!
SBRWCB_LButtonUp                     PROCEDURE(Ragazzi_WCB_Class SBRWCB, _HANDLE hwnd, UNSIGNED wParam, SIGNED lParam) !,SIGNED
rect                                 LIKE(_RECT_)
pt                                   LIKE(POINT)
NotifyCode                           UNSIGNED
   CODE
!      SBRWCB_DebugWrite('SBRWCB : LButtonUp : ' & SBRWCB.ActiveButton)

      pt.x = SBRWCB_LoWord(lParam)
      pt.y = SBRWCB_HiWord(lParam)
      ClientToScreen(hwnd, pt)

      IF(SBRWCB.MouseDown)
         ReleaseCapture()

         SBRWCB_GetButtonRect(SBRWCB, hwnd, SBRWCB.ActiveButton, rect, False)
         SBRWCB_API_InflateRect(rect, 0, 2)

        ! if clicked in a custom button
         IF(PtInRect(rect, pt))

        !!  SendMessage(hwnd, WM_COMMAND, NotifyCode, SBRWCB_MakeWord(pt.x, pt.y))

            NotifyCode = SBRWCB.Buttons[SBRWCB.ActiveButton].NotifyCode

            NOTIFY(NotifyCode, THREAD(),SBRWCB.ActiveButton)
         END

         SBRWCB.Buttons[SBRWCB.ActiveButton].Pressed = False
         SBRWCB.MouseDown                            = False

         SBRWCB_RedrawNC(hwnd)

         RETURN 0
      END

      RETURN CallWindowPROC(SBRWCB.OldWndPROC, hwnd, WM_LBUTTONUP, wParam, lParam)
!==============================================================================
SBRWCB_MouseMove                       PROCEDURE(Ragazzi_WCB_Class SBRWCB, _HANDLE hwnd, UNSIGNED wParam, SIGNED lParam) !,SIGNED
rect                                   LIKE(_RECT_)
pt                                     LIKE(POINT)
Pressed                                BYTE
   CODE
!      SBRWCB_DebugWrite('SBRWCB : MouseMove : ')

      pt.x = SBRWCB_LoWord(lParam)
      pt.y = SBRWCB_HiWord(lParam)
      ClientToScreen(hwnd, pt)

      IF(SBRWCB.MouseDown)
         SBRWCB_GetButtonRect(SBRWCB, hwnd, SBRWCB.ActiveButton, rect, False)
         SBRWCB_API_InflateRect(rect, 0, 2)

         Pressed = PtInRect(rect, pt)

         IF(Pressed NOT = SBRWCB.Buttons[SBRWCB.ActiveButton].Pressed)
            SBRWCB.Buttons[SBRWCB.ActiveButton].Pressed = BXOR(SBRWCB.Buttons[SBRWCB.ActiveButton].Pressed, 1)
            SBRWCB_RedrawNC(hwnd)
         END

         RETURN 0
      END

      RETURN CallWindowPROC(SBRWCB.OldWndPROC, hwnd, WM_MOUSEMOVE, wParam, lParam)
!==============================================================================
! Replacement window PROCedure
SBRWCB_NewWndPROC                       PROCEDURE(_HANDLE hwnd, UNSIGNED pmsg, UNSIGNED wParam, SIGNED lParam) !,SIGNED
SBRWCB                                     &Ragazzi_WCB_Class,AUTO
OldWndPROC                                 UNSIGNED,AUTO

   CODE
!?     SBRWCB_DebugWrite('SBRWCB : NewWndPROC : hwnd=' & hwnd)

      SBRWCB &= SBRWCB_GetWinCapBtn(hwnd)
      IF (SBRWCB &= NULL)
          SBRWCB_DebugWrite('SBRWCB : NewWndPROC : (SBRWCB &= NULL)')
          HALT()
      END

      OldWndPROC = SBRWCB.OldWndPROC

      CASE pmsg
            ! clean up when window is destroyed
        OF WM_NCDESTROY
!?                     SBRWCB_DebugWrite('SBRWCB : NewWndPROC : WM_NCDESTROY')
                     !------------------------------------------------------------------
        OF WM_NCHITTEST
!?                     SBRWCB_DebugWrite('SBRWCB : NewWndPROC : WM_NCHITTEST')

                      RETURN SBRWCB_NCHitTest   (SBRWCB, hwnd, wParam, lParam)
                     !------------------------------------------------------------------
            ! These three messages all cause the caption to
            ! be repainted, so we have to _HANDLE all three to properly
            ! support inserted buttons
        OF WM_NCACTIVATE
!?                    SBRWCB_DebugWrite('SBRWCB : NewWndPROC : WM_NCACTIVATE')
                     !------------------------------------------------------------------
                     RETURN SBRWCB_NCActivate   (SBRWCB, hwnd, wParam, lParam)

        OF WM_SETTEXT
!?                    SBRWCB_DebugWrite('SBRWCB : NewWndPROC : WM_SETTEXT')

                     RETURN SBRWCB_SetText      (SBRWCB, hwnd, wParam, lParam)
                     !------------------------------------------------------------------
        OF WM_NCPAINT
!?                    SBRWCB_DebugWrite('SBRWCB : NewWndPROC : WM_NCPAINT')

                     RETURN SBRWCB_NCPaint      (SBRWCB, hwnd, wParam)
                     !------------------------------------------------------------------
            ! Mouse support
        OF WM_NCLBUTTONDBLCLK
      OROF WM_NCLBUTTONDOWN
!?                    SBRWCB_DebugWrite('SBRWCB : NewWndPROC : WM_NCLBUTTONDOWN')

                     RETURN SBRWCB_NCLButtonDown(SBRWCB, hwnd, pmsg, wParam, lParam)
                     !------------------------------------------------------------------
        OF WM_LBUTTONUP
!?                    SBRWCB_DebugWrite('SBRWCB : NewWndPROC : WM_LBUTTONUP')

                     RETURN SBRWCB_LButtonUp    (SBRWCB, hwnd, wParam, lParam)
                     !------------------------------------------------------------------
        OF WM_MOUSEMOVE
!?                    SBRWCB_DebugWrite('SBRWCB : NewWndPROC : WM_MOUSEMOVE')

                     RETURN SBRWCB_MouseMove    (SBRWCB, hwnd, wParam, lParam)
      END

!?     SBRWCB_DebugWrite('SBRWCB : NewWndPROC : Fallthru : ' & pmsg)

    ! call the old window PROCedure
      RETURN CallWindowPROC(OldWndPROC, hwnd, pmsg, wParam, lParam)
!==============================================================================
!
!   Insert a button into specified window's titlebar
!
SBRWCB_InsertButton                     PROCEDURE(_HANDLE hwnd, *t_SBRWCB_Btn pBtnInfo) !,BYTE
SBRWCB                                  &Ragazzi_WCB_Class
wBtnNo                                  SIGNED
wReturnValue                            SIGNED
   CODE
      SBRWCB &= SBRWCB_GetWinCapBtn(hwnd)

      IF(SBRWCB &= NULL)
         SBRWCB_DebugWrite('SBRWCB : InsertButton : * FAILED * : (SBRWCB &= NULL)')

         RETURN False
      END

      SBRWCB.ButtonCnt      += 1

      wBtnNo                 = SBRWCB.ButtonCnt

      SBRWCB.Buttons[wBtnNo] = pBtnInfo

!?     SBRWCB_DebugWrite('SBRWCB : InsertButton : hwnd      =' & SBRWCB_LongToHex(hwnd))
!?     SBRWCB_DebugWrite('SBRWCB : InsertButton : hImage    =' & SBRWCB_LongToHex(pBtnInfo.hImage ))
!?     SBRWCB_DebugWrite('SBRWCB : InsertButton : NotifyCode=' & pBtnInfo.NotifyCode )
!?     SBRWCB_DebugWrite('SBRWCB : InsertButton : pBorder   =' & pBtnInfo.RightBorder)

      RETURN True
!==============================================================================
!
!   Remove the last inserted button from window's titlebar
!
SBRWCB_RemoveButton                     PROCEDURE(_HANDLE hwnd) !,BYTE,PROC
SBRWCB                                  &Ragazzi_WCB_Class
   CODE

      SBRWCB &= SBRWCB_GetWinCapBtn(hwnd)

      IF(SBRWCB &= NULL)
         RETURN False
      END

      IF(SBRWCB.ButtonCnt > 0)
         SBRWCB.ButtonCnt -= 1
         SBRWCB_RedrawNC(hwnd)
      END

      RETURN True
!=============================================================================================
SBRWCB_MakeIntResource                  PROCEDURE(SHORT wInteger) !,SIGNED

wReturnInteger  SIGNED
wWords          GROUP,OVER(wReturnInteger)
HiWord              SHORT
LoWord              SHORT
                END
    CODE
    
    wWords.LoWord  = wInteger
    wWords.HiWord  = 0
    
    RETURN wReturnInteger
!=============================================================================================
SBRWCB_MakeWord                         PROCEDURE(BYTE LowByte, BYTE HiByte) !,SHORT
aWord                                   SHORT
   CODE
      aWord = LowByte + BSHIFT(HiByte, 8)

      RETURN aWord
!=============================================================================================
SBRWCB_LoWord                           PROCEDURE(LONG nValue)
aWord                                   SHORT
   CODE

      aWord = nValue

      RETURN aWord
!=============================================================================================
SBRWCB_HiWord                           PROCEDURE(LONG nValue)
aWord                                   SHORT
   CODE

      aWord = BSHIFT(nValue, -16)

      RETURN aWord
!=============================================================================================
SBRWCB_DebugWrite                       PROCEDURE(STRING pS)
wMsg                                    CSTRING(2048)
wLastError                              SIGNED
   CODE

      wLastError = GetLastError()
      
      wMsg = THREAD() & '] ' & CLIP(pS) 
      IF wLastError
         wMsg = wMsg & ' : LastError=' & wLastError
      END

      SBRWCB_API_OutputDebugString(wMsg)

      SBRWCB_API_SetLastError(0)
      
      RETURN
!=============================================================================================
SBRWCB_LongToHex                     PROCEDURE(LONG pDecValue) !!,String
HexStr                                  CSTRING(255)
FormatStr                               CSTRING('%08X')
   CODE

      SBRWCB_API_SPrintF(HexStr,FormatStr,pDecValue)

      RETURN(HexStr)
!=============================================================================================
SBRWCB_ReplaceText                             PROCEDURE  (*? pLineOfText, STRING pSearchFor, STRING pReplaceWith, BYTE pCaseSensitive=0, BYTE p1stOnly=0, BYTE pTrace=0) !,LONG,PROC ! Declare PROCedure
wStartPos                               LONG,AUTO                !
wFoundPos                               LONG,AUTO                !
wSearchLen                              LONG,AUTO                !
wReplaceLen                             LONG,AUTO                !
wLineOfTextLen                          LONG,AUTO                !
wLineOfText                             &STRING,AUTO             !
wOriginalLen                            LONG,AUTO                !

wDeltaLength                            LONG,AUTO
wDeltaCount                             LONG,AUTO
wDeltaTotal                             LONG,AUTO

   CODE
      wDeltaLength = 0
      wDeltaCount  = 0
      wDeltaTotal  = 0
!-
!- If equal, no Changes need to be done
!-
      IF pSearchFor = pReplaceWith OR CLIP(pLineOfText) = ''
         RETURN 0
      END
!-
      wLineOfTextLen  = LEN(pLineOfText)
      wLineOfText    &= NEW STRING(wLineOfTextLen)
      wLineOfText     = pLineOfText
!-
      wSearchLen   = LEN(pSearchFor)
      wReplaceLen  = LEN(pReplaceWith)
      wDeltaLength = CHOOSE(wReplaceLen >= wSearchLen , |
                            wReplaceLen  - wSearchLen , |
                            wSearchLen   - wReplaceLen) ! Decrease in Size
!-
      IF pTrace
         SBRWCB_DebugWrite('SBRWCB : ReplaceText : CS='     & pCaseSensitive            |
                           & ' FO='     & p1stOnly                  |
                           & ' SL='     & FORMAT(wSearchLen,@N_3)   |
                           & ' SF=['    & pSearchFor                |
                           & '] RL='    & wReplaceLen               |
                           & ' RW=['    & pReplaceWith              |
                           & '] TL='    & wLineOfTextLen            |
                           & ' Delta='  & wDeltaLength)
      END
!-
      IF pCaseSensitive
      ELSE
         pSearchFor = UPPER(pSearchFor)
      END
!-
      wDeltaCount = 0
      wStartPos   = 1
!-
      LOOP
         IF wStartPos > wLineOfTextLen
            BREAK
         END
   !-
         IF pCaseSensitive
            wFoundPos = INSTRING(pSearchFor,      wLineOfText ,1,wStartPos)
         ELSE
            wFoundPos = INSTRING(pSearchFor,UPPER(wLineOfText),1,wStartPos)
         END
!-
         IF wFoundPos = 0
            BREAK
         END
   !-
         IF (wFoundPos + wSearchLen) > wLineOfTextLen
            SBRWCB_DebugWrite('SBRWCB : ReplaceText : ** ERROR ** *BUFFER OVERFLOW*'    |
                            & ' IC=' & wDeltaCount                  |
                            & ' SP=' & wStartPos                    |
                            & ' TL=' & wLineOfTextLen               |
                            & ' FP=' & wFoundPos                    |
                            & ' TX=' & pSearchFor)
            BREAK
         END
   !-
         wDeltaCount += 1
   !-
         wLineOfText = wLineOfText [ 1 : (wFoundPos - 1) ]  |
                     & pReplaceWith                         |
                     & wLineOfText [ (wFoundPos + wSearchLen) : wLineOfTextLen  ]
   !-
         IF p1stOnly
            BREAK
         END
   !-
         wStartPos = (wFoundPos + wReplaceLen)
      END
!-
      IF wDeltaCount
         wDeltaTotal = wDeltaLength * wDeltaCount
         pLineOfText = wLineOfText
         IF pTrace
            SBRWCB_DebugWrite('SBRWCB : ReplaceText : ' & FORMAT(wDeltaTotal,@N-_6)     |
                                    & ' Changed '                   |
                                    & FORMAT( wDeltaCount  ,@N-_4)  |
                                    & ' with delta size of '        |
                                    & FORMAT( wDeltaLength ,@N-_3)  |
                                    & ' Srch= ['                    |
                                    & pSearchFor                    |
                                    & '] ('                         |
                                    & wSearchLen                    |
                                    & ')' & ' Repl= ['              |
                                    & pReplaceWith                  |
                                    & '] ('                         |
                                    & wReplaceLen                   |
                                    & ')')
         END
      END
!-
      DISPOSE(wLineOfText)
!-
      RETURN wDeltaTotal
!==============================================================================
SBRWCB_EnumResNameProc                  PROCEDURE(_HINSTANCE hInst, LONG lpszType, LONG lpszName, LONG lParam) !,_BOOL,PASCAL
szType                                  &CSTRING
szTypePredefined                         CSTRING('Pre-Defined type')
szName                                  &CSTRING
   CODE

      IF (BAND(lpszType, 0FFFF0000h))
         szType &= (lpszType)
      ELSE
         szType &= szTypePredefined
      END
      
      IF (BAND(lpszName, 0FFFF0000h))
         szName &= (lpszName)
         SBRWCB_DebugWrite('SBRWCB : EnumResName :      Name=' &   szName)
      ELSE
         SBRWCB_DebugWrite('SBRWCB : EnumResName :      Name=' & lpszName)
      END

      RETURN True
!==============================================================================
SBRWCB_EnumResTypeProc                  PROCEDURE(_HINSTANCE hInst, LONG lpszType, LONG lParam) !,_BOOL,PASCAL
szType                                  &CSTRING
wPredefinedType                          CSTRING(16)
   CODE

      IF (BAND(lpszType, 0FFFF0000h))
         szType &= (lpszType)
         SBRWCB_DebugWrite('SBRWCB : EnumResType : Type=' & SBRWCB_LongToHex(lpszType) & ' [' & szType & ']' & lpszType)
      ELSE
         CASE lpszType
           OF RT_CURSOR            ; wPredefinedType = 'RT_CURSOR      '
           OF RT_BITMAP            ; wPredefinedType = 'RT_BITMAP      '
           OF RT_ICON              ; wPredefinedType = 'RT_ICON        '
           OF RT_MENU              ; wPredefinedType = 'RT_MENU        '
           OF RT_DIALOG            ; wPredefinedType = 'RT_DIALOG      '
           OF RT_STRING            ; wPredefinedType = 'RT_STRING      '
           OF RT_FONTDIR           ; wPredefinedType = 'RT_FONTDIR     '
           OF RT_FONT              ; wPredefinedType = 'RT_FONT        '
           OF RT_ACCELERATOR       ; wPredefinedType = 'RT_ACCELERATOR '
           OF RT_RCDATA            ; wPredefinedType = 'RT_RCDATA      '
           OF RT_MESSAGETABLE      ; wPredefinedType = 'RT_MESSAGETABLE'
           OF RT_GROUP_CURSOR      ; wPredefinedType = 'RT_GROUP_CURSOR'
           OF RT_GROUP_ICON        ; wPredefinedType = 'RT_GROUP_ICON  '
           OF RT_VERSION           ; wPredefinedType = 'RT_VERSION     '
           OF RT_DLGINCLUDE        ; wPredefinedType = 'RT_DLGINCLUDE  '
           OF RT_PLUGPLAY          ; wPredefinedType = 'RT_PLUGPLAY    '
           OF RT_VXD               ; wPredefinedType = 'RT_VXD         '
           OF RT_ANICURSOR         ; wPredefinedType = 'RT_ANICURSOR   '
           OF RT_ANIICON           ; wPredefinedType = 'RT_ANIICON     '
         ELSE                      ; wPredefinedType = ''
         END
         SBRWCB_DebugWrite('SBRWCB : EnumResType : Type=' & SBRWCB_LongToHex(lpszType) & ' ' & wPredefinedType)
      END

      RETURN SBRWCB_API_EnumResourceNames(hInst, lpszType, ADDRESS(SBRWCB_EnumResNameProc), 2)
!==============================================================================
!==============================================================================
!== http:!support.microsoft.com/kb/124947/EN-US/
!==============================================================================
SBRWCB_CreateDIBPalette                 PROCEDURE(_BITMAPINFO pBitmapInfo, *SIGNED lpiNumColors) !,SIGNED

wBitmapInfoHeader                       LIKE(_BitmapInfoHeader)
lpPal                                   &_LogPalette
hLogPal                                 _HANDLE
hPal                                    SIGNED
i                                       SIGNED
   CODE

      RETURN 0
      
      wBitmapInfoHeader = pBitmapInfo

!?     SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette : biSize         =' & wBitmapInfoHeader.biSize         )
!?     SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette : biWidth        =' & wBitmapInfoHeader.biWidth        )
!?     SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette : biHeight       =' & wBitmapInfoHeader.biHeight       )
!?     SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette : biPlanes       =' & wBitmapInfoHeader.biPlanes       )
!?     SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette : biBitCount     =' & wBitmapInfoHeader.biBitCount     )
!?     SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette : biCompression  =' & wBitmapInfoHeader.biCompression  )
!?     SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette : biSizeImage    =' & wBitmapInfoHeader.biSizeImage    )
!?     SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette : biXPelsPerMeter=' & wBitmapInfoHeader.biXPelsPerMeter)
!?     SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette : biYPelsPerMeter=' & wBitmapInfoHeader.biYPelsPerMeter)
!?     SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette : biClrUsed      =' & wBitmapInfoHeader.biClrUsed      )
!?     SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette : biClrImportant =' & wBitmapInfoHeader.biClrImportant )

      IF (wBitmapInfoHeader.biBitCount <= 8)
         lpiNumColors = BSHIFT(1,wBitmapInfoHeader.biBitCount)
      ELSE
         lpiNumColors = 0                                        ! No palette needed for 24 BPP DIB
      END
!?     SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette  1: lpiNumColors=' & lpiNumColors)

      IF (wBitmapInfoHeader.biClrUsed > 0)
         lpiNumColors = wBitmapInfoHeader.biClrUsed              ! Use biClrUsed
      END

!?     SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette  2: lpiNumColors=' & lpiNumColors)

      IF ~lpiNumColors
         RETURN hPal
      END

      hLogPal = GlobalAlloc(GHND, SIZE (_LogPalette) + SIZE (_PaletteEntry) * lpiNumColors)
!?        SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette  : GlobalAlloc : hLogPal=' & SBRWCB_LongToHex(hLogPal))

      lpPal = GlobalLock (hLogPal)

!?        SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette  : GlobalLock  : lpPal  =' & SBRWCB_LongToHex(lpPal))


      lpPal.palVersion    = 0300h
      lpPal.palNumEntries = lpiNumColors

      LOOP i= 1 TO lpiNumColors                                  !for (i = 0  i < *lpiNumColors  i++)
         lpPal.palPalEntry[i].peRed   = pBitmapInfo.bmiColors[i].rgbRed
         lpPal.palPalEntry[i].peGreen = pBitmapInfo.bmiColors[i].rgbGreen
         lpPal.palPalEntry[i].peBlue  = pBitmapInfo.bmiColors[i].rgbBlue
         lpPal.palPalEntry[i].peFlags = 0
      END

      hPal = SBRWCB_API_CreatePalette(lpPal)

!?        SBRWCB_DebugWrite('SBRWCB : CreateDIBPalette  : CreatePalette  : hPal  =' & SBRWCB_LongToHex(hPal))

      GlobalUnlock (hLogPal)
      GlobalFree   (hLogPal)

      RETURN hPal
!==============================================================================
